
#include "sssd.h"
#include "internals.h"


#define VAARGS_FLOAT_TYPE double
#define VAARGS_FLOAT_POINTER_TYPE double *

int sssd_ctrlDevice( struct sssdaudio* ga, float *argArray)
{
    int parm;
    
    /* Vars needed for Linux */
    int mixer_fd=0;

    /* Values that we know about */
    float unknown=-1;
    float volume=-1;
    float pan=-1;

#ifndef __NOPRINTING__
  puts("sssd_ctrlDevice()");
#endif
    
    ga->lastERR=0;

    /* Args were passed in an array rather than varargs */
    if(argArray!=NULL) {
    
      while((int)*argArray!=CTRL_D_END) {
        parm=(int)*argArray;argArray++;
        if(parm==CTRL_D_VOLUME) {
	   volume=*argArray;
	}
	else
	if(parm==CTRL_D_PAN) {
	   pan=*argArray;
	}
	else {
	   ga->lastERR=ERR_DEVICE_UNKNOWN;
	   unknown=*argArray;
	}
        argArray++;

      }      
    }
    /* Check to make sure we have something to change */
    if(volume==-1 && pan==-1) return ga->lastERR;
    
    /* Apply parameters */
    if( (mixer_fd=open("/dev/mixer", O_WRONLY, 0))==-1) {
       ga->lastERR=-111;
       return -111;
    }
    
    /* Change master volume */
    if(volume!=-1)
    {
      int vol=volume*100;
      vol|=(vol<<8);
      ioctl( mixer_fd, SOUND_MIXER_WRITE_PCM, &vol);
    }
        
    /* Change master pan */
    if(pan!=-1)
    {
      int lpan,rpan,ovol,avol,lvol,rvol;
      
      ioctl(mixer_fd, SOUND_MIXER_READ_PCM, &ovol);
      lvol=(ovol&0xFF);
      rvol=((ovol>>8)&0xFF);            
      avol=MAX(lvol,rvol);
      lpan=rpan=avol;
      if(pan>.5) lpan=avol*(1-(float)(pan-.5)*2);
      if(pan<.5) rpan=avol*((float)pan*2);
      ovol=((rpan<<8)|(lpan&0xFF))&0xFFFF;
      ioctl( mixer_fd, SOUND_MIXER_WRITE_PCM, &ovol);      
    
    }
    
    close(mixer_fd);
    
return ga->lastERR;
}
