
#include "sssd.h"
#include "internals.h"

int sssd_ctrlSample( struct sssdaudio* ga, int sample_id, int *argArray)
{
    int i,parm=0;
    struct ga_playing* curplaying;
    int a=0,b,byps=ga->byps;

    /* Values that we know about */
    int unknown=-1;
    int volume=-1;
    int ovolume=0;
    int pan=-1;
    int opan=0;
    int playStart=-1;
    int playEnd=-1;
    int loopStart=-1;
    int loopEnd=-1;
    int loopCount=-100;
    
#ifndef __NOPRINTING__
  puts("sssd_ctrlSample()");
#endif
    
    /* Args were passed in an array rather than varargs */
    if(argArray!=NULL) {
    
      while(*argArray!=CTRL_S_END) {
        i=*argArray;argArray++;
	if(i==CTRL_S_VOLUME) {
	   volume=*argArray;
	}
	else
	if(i==CTRL_S_PAN) {
	   pan=*argArray;
	}
	if(parm==CTRL_S_PLAYSTART) {
	   playStart=*argArray;
	}
	else
	if(parm==CTRL_S_PLAYEND) {
	   playEnd=*argArray;
	}
	else
	if(parm==CTRL_S_LOOPSTART) {
	   loopStart=*argArray;
	}
	else
	if(parm==CTRL_S_LOOPEND) {
	   loopEnd=*argArray;
	}
	else
	if(parm==CTRL_S_LOOPCOUNT) {
	   loopCount=*argArray;
	}
	else {
	   ga->lastERR=ERR_SAMPLES_ATTRIB;
	   unknown=*argArray;
	}
	argArray++;      
    
      }
    }

#ifndef __NOPRINTING__
  printf("sssd_ctrlSample: pan=%03d  volume=%03d\n",pan,volume);
#endif

    /* Convert 'PAN' from -128-0-128 to 0-128-256 */
    if(pan!=-1) pan+=128;
    
    LOCK_BUFFERS_NP(ga);


    /* Apply parameters */

    /* Loop through playlist and set parameters for entries that match the id */
    curplaying = ga->playing;
    
    if (sample_id<0) {  /* playing samples with playing_id == sample_id (which is really a playing ID) */

     for( i = 0; i < ga->num_playing; i++ )
     {
        if( curplaying->playing_id == sample_id )
        {
	   if(volume>-1 || pan>-1) {

	    /* Pan/Volume */
	    if(ga->channels==1) {
	      if( volume>-1 ) curplaying->b=volume;
	    } else {
	      /* get old parameters */
	      a=curplaying->a;
	      b=curplaying->b;
	      ovolume=(a+b);
	      opan=((a-b)+256)>>1;
              
	      /* Set parameters */
              if(volume==-1) volume=ovolume;
	      if(pan==-1) pan=opan;
              a=(volume*(256-pan))>>8;
              b=(volume*(pan))>>8;	      
	      curplaying->a=a;
              curplaying->b=b;
	    }
	  }	      	      

          byps=ga->byps;
          if(curplaying->voiceflags&PLAYFLAG_CHANCHANGE) {
                    if(ga->channels==2) byps>>=1;
                    else
                    if(ga->channels==1) byps<<=1;
          }


	      if(playStart!=-1) {
	         curplaying->playpos=(void *)((playStart*byps)+(int)curplaying->rootpos);	      
	      }
	      if(playEnd!=-1) {
		 curplaying->playend=(void *)((playEnd*byps)+(int)curplaying->rootpos);	      	      
	      }
	      if(loopStart!=-1) {
		 curplaying->looppos=(void *)((loopStart*byps)+(int)curplaying->rootpos);	      	      	      
	      }
	      if(loopEnd!=-1) {
		 curplaying->loopend=(void *)((loopEnd*byps)+(int)curplaying->rootpos);
		 if(curplaying->curpos > curplaying->loopend && curplaying->repeat_count!=1){ 
		    curplaying->curpos=curplaying->looppos;
		    if( curplaying->repeat_count > 1 ) curplaying->repeat_count--;
		 }   	      	      	      
	      }
	      if(loopCount!=-100) {
	          curplaying->repeat_count=loopCount;
	      }
	      

        }
        else
        {
            /* Next in playlist */
            curplaying++;
        }
     }

    } else { /* all playing samples with the Sample ID 'sample_id' */
    
     for( i = 0; i < ga->num_playing; i++ )
     {
        if( curplaying->sample_id == sample_id )
        {
	   if(volume>-1 || pan>-1) {
	    /* Pan/Volume */
	    if(ga->channels==1) {
	      if( volume>-1 ) curplaying->b=volume;
	    } else {
	      /* get old parameters */
	      a=curplaying->a;
	      b=curplaying->b;
	      ovolume=(a+b);
	      opan=((a-b)+256)>>1;
	      /* Set parameters */
              if(volume==-1) volume=ovolume;
	      if(pan==-1) pan=opan;
              a=(volume*(256-pan))>>8;
              b=(volume*(pan))>>8;	      
	      curplaying->a=a;
              curplaying->b=b;
	   }	      
	  }
          
          byps=ga->byps;
          if(curplaying->voiceflags&PLAYFLAG_CHANCHANGE) {
                    if(ga->channels==2) byps>>=1;
                    else
                    if(ga->channels==1) byps<<=1;
          }
	      
          /* Set sample parameters */
	      if(playStart!=-1) {
	         curplaying->playpos=(void *)((playStart*byps)+(int)curplaying->rootpos);	      
	      }
	      if(playEnd!=-1) {
		 curplaying->playend=(void *)((playEnd*byps)+(int)curplaying->rootpos);	      	      
	      }
	      if(loopStart!=-1) {
		 curplaying->looppos=(void *)((loopStart*byps)+(int)curplaying->rootpos);	      	      	      
	      }
	      if(loopEnd!=-1) {
		 curplaying->loopend=(void *)((loopEnd*byps)+(int)curplaying->rootpos);
		 if(curplaying->curpos > curplaying->loopend && curplaying->repeat_count!=1){ 
		    curplaying->curpos=curplaying->looppos;
		    if( curplaying->repeat_count > 1 ) curplaying->repeat_count--;
		 }   	      	      	      
	      }
	      if(loopCount!=-100) {
	          curplaying->repeat_count=loopCount;
	      }
	      

        }
        else
        {
            /* Next in playlist */
            curplaying++;
        }
     }


    } /* Playing or Sample number for sample_id */
    
    
    UNLOCK_BUFFERS_NP(ga);

return ga->lastERR;
}
