

#include "sssd.h"
#include "internals.h"

struct sssdaudio* sssd_initAudio(int channels, int freq, int bits, int max_voices, int max_samples, int buffersize, int numbuffers, int flags)
{

   struct sssdaudio *ga;
   ga=malloc(sizeof(struct sssdaudio));
   if(!ga) {
      return NULL;
   }
   ga->channels=channels;
   ga->freq=freq;
   ga->bits=bits;
   ga->max_voices=max_voices;
   ga->max_samples=max_samples;
   ga->flags=flags;
#ifdef __SYMBIAN32__
    ga->flags=ga->flags|SSSDSYS_CONSTRATE;
#endif
   ga->byps=channels;
   if(bits==16) ga->byps<<=1;
   
   ga->audioBufferSize=buffersize;
   if(numbuffers>MAX_AUDIO_BUFFERS) numbuffers=MAX_AUDIO_BUFFERS;
   else if(numbuffers==0) numbuffers=DEFAULT_NUM_AUDIO_BUFFERS;
   ga->numAudioBuffers=numbuffers;
   
   return ga;
}
