#include "sssd.h"
#include "internals.h"

/*
    Stop all playing samples with the given id.
*/

void sssd_stopSample( struct sssdaudio* ga, int sample_id )
{
    int i;
    struct ga_playing* curplaying;

    /* Sanity check on id */
    if( (sample_id < 0) || (sample_id >= ga->num_samples) )
        return;

    LOCK_BUFFERS_NP(ga);

    /* Loop through playlist and remove all entries that match id */
    curplaying = ga->playing;

    if (sample_id<0) {
     for( i = 0; i < ga->num_playing; i++ )
     {
        if( curplaying->playing_id == sample_id )
        {
            /* Done - delete from list */
            if( i != (ga->num_playing-1) )
            {
                ga->playing[ i ] = ga->playing[ ga->num_playing-1 ];
            }
            ga->num_playing--;
            /* Check entry again */
            i--;
        }
        else
        {
            /* Next in playlist */
            curplaying++;
        }
     }
    } else {
     for( i = 0; i < ga->num_playing; i++ )
     {
        if( curplaying->sample_id == sample_id )
        {
            /* Done - delete from list */
            if( i != (ga->num_playing-1) )
            {
                ga->playing[ i ] = ga->playing[ ga->num_playing-1 ];
            }
            ga->num_playing--;
            /* Check entry again */
            i--;
        }
        else
        {
            /* Next in playlist */
            curplaying++;
        }
     }
    }
    
    UNLOCK_BUFFERS_NP(ga);
}

